﻿Imports FarPoint.Win.Spread
Imports FarPoint.Win.Spread.DrawingSpace
Imports FarPoint.Win.Spread.Model
Imports System
Imports System.Windows.Forms

Namespace Spread_NoteEvent
    Public Class FpSpreadEx
        Inherits FpSpread

        Public Event NoteClicked As EventHandler(Of NoteClickedEventArgs)

        Protected Overrides Sub OnMouseDown(ByVal e As MouseEventArgs)
            Dim notesContainer = ActiveSheet.NotesContainer

            If CType(notesContainer.ChildContains(e.Location, False), Internal.StickyNoteCommentBase) IsNot Nothing Then
                Dim cellNote = CType(notesContainer.ChildContains(e.Location, False), Internal.StickyNoteCommentBase)
                Dim cr As CellRange = CType(cellNote.GetType().GetProperty("CellRange").GetValue(cellNote), CellRange)
                RaiseEvent NoteClicked(Me, New NoteClickedEventArgs(cr.Row, cr.Column))
            End If

            MyBase.OnMouseDown(e)
        End Sub
    End Class

    Public Class NoteClickedEventArgs
        Inherits EventArgs

        Private _Row As Integer, _Column As Integer

        Public Sub New(ByVal row As Integer, ByVal col As Integer)
            Me.Row = row
            Column = col
        End Sub

        Public Property Row As Integer
            Get
                Return _Row
            End Get
            Private Set(ByVal value As Integer)
                _Row = value
            End Set
        End Property

        Public Property Column As Integer
            Get
                Return _Column
            End Get
            Private Set(ByVal value As Integer)
                _Column = value
            End Set
        End Property
    End Class
End Namespace
